searchData={"items":[{"type":"module","title":"Paradex","doc":"A collection of macros for composing ParadeDB queries.","ref":"Paradex.html"},{"type":"macro","title":"Paradex.all/0","doc":"Macro for [paradedb.all](https://docs.paradedb.com/documentation/advanced/compound/all).\n\n    from(\n      c in Call,\n      where: c.id ~> all()\n    )","ref":"Paradex.html#all/0"},{"type":"macro","title":"Paradex.boolean/1","doc":"Macro for [paradedb.boolean](https://docs.paradedb.com/documentation/advanced/compound/boolean).\n\nEach value must be a literal Keyword list at the top level, where each value is a list:\n    x = \"transcript:transfer\"\n\n    from(\n      c in Call,\n      where: c.id ~> boolean(\n        must: [parse(^x)],\n        must_not: [parse(\"transcript:station\")]\n      )\n    )\n\nKeys other than `must`, `should`, and `must_not` are ignored, so be wary of misspelling.","ref":"Paradex.html#boolean/1"},{"type":"macro","title":"Paradex.boost/2","doc":"Macro for [paradedb.boost](https://docs.paradedb.com/documentation/advanced/compound/boost).\n\n    from(\n      c in Call,\n      select: {c. score(c.id)},\n      boost(2.0, \"transcript:bus\")\n    )","ref":"Paradex.html#boost/2"},{"type":"macro","title":"Paradex.const_score/2","doc":"Macro for [paradedb.const_score](https://docs.paradedb.com/documentation/advanced/compound/const).\n\n    from(\n      c in Call,\n      select: {c, score(c.id)},\n      where: c.id ~> const_score(2.0, parse(\"transcript:bus\"))\n    )","ref":"Paradex.html#const_score/2"},{"type":"macro","title":"Paradex.daterange/4","doc":"Macro for [paradedb.range](https://docs.paradedb.com/documentation/advanced/term/range) using the `date` data type.\n\n    start = ~D[2024-10-09]\n    stop = ~D[2024-10-10]\n\n    query =\n      from(\n        c in Call,\n        where: c.id ~> daterange(\"start_time\", ^start, ^stop, \"[]\")\n      )","ref":"Paradex.html#daterange/4"},{"type":"macro","title":"Paradex.disjunction_max/2","doc":"Macro for [paradedb.disjunction_max](https://docs.paradedb.com/documentation/advanced/compound/disjunction_max).\n\n    from(\n      c in Call,\n      where:\n        c.id ~> disjunction_max([\n          parse(\"transcript:bus\"),\n          int4range(\"call_length\", 10, nil, \"[)\")\n        ])\n    )","ref":"Paradex.html#disjunction_max/2"},{"type":"macro","title":"Paradex.empty/0","doc":"Macro for [paradedb.empty](https://docs.paradedb.com/documentation/advanced/compound/empty).\n\n    from(\n      c in Call,\n      where: c.id ~> empty()\n    )","ref":"Paradex.html#empty/0"},{"type":"function","title":"Paradex.extensions/0","doc":"Type extensions for Postgrex, for usage in `Postgrex.Types.define/3`.","ref":"Paradex.html#extensions/0"},{"type":"macro","title":"Paradex.fuzzy_term/5","doc":"Macro for [paradedb.fuzzy_term](https://docs.paradedb.com/documentation/advanced/term/fuzzy_term).\n\n    from(\n      c in Call,\n      where: c.id ~> fuzzy_term(\"transcript\", \"bus\", 2, true, false)\n    )","ref":"Paradex.html#fuzzy_term/5"},{"type":"macro","title":"Paradex.int4range/4","doc":"Macro for [paradedb.range](https://docs.paradedb.com/documentation/advanced/term/range) using the `int4` data type.\n\n    from(\n      c in Call,\n      where: c.id ~> int4range(\"call_length\", 5, nil, \"[)\")\n    )","ref":"Paradex.html#int4range/4"},{"type":"macro","title":"Paradex.int8range/4","doc":"Macro for [paradedb.range](https://docs.paradedb.com/documentation/advanced/term/range) using the `int8` data type.\n\n    from(\n      c in Call,\n      where: c.id ~> int8range(\"call_length\", 5, nil, \"[)\")\n    )","ref":"Paradex.html#int8range/4"},{"type":"macro","title":"Paradex.match/6","doc":"Macro for [paradedb.match](https://docs.paradedb.com/documentation/advanced/full-text/match).\n\n    from(\n      c in Call,\n      where: c.id ~> match(\"transcript\", \"bus stop\")\n    )","ref":"Paradex.html#match/6"},{"type":"macro","title":"Paradex.parse/3","doc":"Macro for [paradedb.parse](https://docs.paradedb.com/documentation/advanced/compound/parse).\n\n    from(\n      c in Call,\n      where: c.id ~> parse(\"transcript:bus\")\n    )","ref":"Paradex.html#parse/3"},{"type":"macro","title":"Paradex.parse_with_field/4","doc":"Macro for [paradedb.parse_with_field](https://docs.paradedb.com/documentation/advanced/compound/parse#parse-with-field).\n\n    from(\n      c in Call,\n      where: c.id ~> parse_with_field(\"transcript\", \"traffic congestion\")\n    )","ref":"Paradex.html#parse_with_field/4"},{"type":"macro","title":"Paradex.pdb_exists/1","doc":"Macro for [paradedb.exists](https://docs.paradedb.com/documentation/advanced/term/exists#exists).\n\nPrefixed with `pdb_` to avoid conflicting with `Ecto.Query.API.exists/1`.\n\n    from(\n      c in Call,\n      where: c.id ~> pdb_exists(\"call_length\")\n    )","ref":"Paradex.html#pdb_exists/1"},{"type":"macro","title":"Paradex.phrase/3","doc":"Macro for [paradedb.phrase](https://docs.paradedb.com/documentation/advanced/phrase/phrase).\n\n    from(\n      c in Call,\n      where: c.id ~> phrase(\"transcript\", [\"bus\", \"stop\"], 1)\n    )","ref":"Paradex.html#phrase/3"},{"type":"macro","title":"Paradex.phrase_prefix/3","doc":"Macro for [paradedb.phrase_prefix](https://docs.paradedb.com/documentation/advanced/phrase/phrase_prefix).\n\n    from(\n      c in Call,\n      where: c.id ~> phrase_prefix(\"transcript\", [\"en\"])\n    )","ref":"Paradex.html#phrase_prefix/3"},{"type":"macro","title":"Paradex.range_term/2","doc":"Macro for [paradedb.range_term](https://docs.paradedb.com/documentation/advanced/term/range_term).","ref":"Paradex.html#range_term/2"},{"type":"macro","title":"Paradex.regex/2","doc":"Macro for [paradedb.regex](https://docs.paradedb.com/documentation/advanced/term/regex). Be mindful that these regular expressions follow [Tantivy's syntax](https://docs.rs/tantivy-fst/latest/tantivy_fst/struct.Regex.html), which follows Rust's regex crate with a few variations.\n\n    from(\n      c in Call,\n      where: c.id ~> regex(\"transcript\", \"(stop|route)\")\n    )","ref":"Paradex.html#regex/2"},{"type":"macro","title":"Paradex.score/0","doc":"","ref":"Paradex.html#score/0"},{"type":"macro","title":"Paradex.score/1","doc":"Returns the BM25 search score for each result, aliasing it as `pdb_score` in the query. Can be used with `score/0` to order results:\n\n    from(\n      c in Call,\n      select: {c, score(c.id)},\n      where: c.transcript ~> \"mechanic\",\n      order_by: [desc: score()]\n    )","ref":"Paradex.html#score/1"},{"type":"macro","title":"Paradex.score_as/1","doc":"","ref":"Paradex.html#score_as/1"},{"type":"macro","title":"Paradex.score_as/2","doc":"Same as `score/1` but uses a variable for the alias instead. Does not support literals.\n\n    score_alias = \"my_score\"\n\n    from(\n      c in Call,\n      select: {c, score_as(c.id, ^score_alias)},\n      where: c.transcript ~> \"mechanic\",\n      order_by: [desc: score_as(^score_alias)]\n    )","ref":"Paradex.html#score_as/2"},{"type":"macro","title":"Paradex.snippet/4","doc":"Macro for [paradedb.snippet](https://docs.paradedb.com/documentation/full-text/highlighting), used for highlighting.\n\n    from(\n      c in Call,\n      select: {c, snippet(c.transcript)},\n      where: c.transcript ~> \"mechanic\"\n    )","ref":"Paradex.html#snippet/4"},{"type":"macro","title":"Paradex.term/2","doc":"Macro for [paradedb.term](https://docs.paradedb.com/documentation/advanced/term/term).\n\n    from(\n      c in Call,\n      where: c.id ~> term(\"talkgroup_num\", 7695)\n    )","ref":"Paradex.html#term/2"},{"type":"macro","title":"Paradex.term_set/1","doc":"Macro for [paradedb.term_set](https://docs.paradedb.com/documentation/advanced/term/term_set).\n\n    from(\n      c in Call,\n      where: c.id ~> term_set([\n        term(\"talkgroup_num\", 7700),\n        term(\"call_length\", 20)\n      ])\n    )","ref":"Paradex.html#term_set/1"},{"type":"macro","title":"Paradex.tsrange/4","doc":"Macro for [paradedb.range](https://docs.paradedb.com/documentation/advanced/term/range) using the `timestamp` data type.\n\n    begin = ~U[2024-10-09 08:00:00.00Z]\n\n    query =\n      from(\n        c in Call,\n        where: c.id ~> tsrange(\"start_time\", ^begin, nil, \"[)\")\n      )","ref":"Paradex.html#tsrange/4"},{"type":"macro","title":"Paradex.~>/2","doc":"Macro for the [`@@@`](https://docs.paradedb.com/documentation/full-text/overview#basic-usage) full text search operator.\n\n`~>` is used as it's one of a few infix operators Elixir's capable of parsing, but aren't presently used.","ref":"Paradex.html#~%3E/2"},{"type":"macro","title":"Examples - Paradex.~>/2","doc":"Search queries can be run on fields directly:\n    import Paradex\n\n    from(\n      c in Call,\n      where: c.transcript ~> \"bus\"\n    )\n\nAlternatively a key field and query object can be used for advanced queries:\n\n    from(\n      c in Call,\n      where: c.id ~> disjunction_max([\n        parse(\"transcript:bus\"),\n        int4range(\"call_length\", 10, nil, \"[)\")\n      ])\n    )","ref":"Paradex.html#~%3E/2-examples"},{"type":"module","title":"Paradex.FieldName","doc":"","ref":"Paradex.FieldName.html"},{"type":"extras","title":"Paradex","doc":"# Paradex\n\nEcto fragments for [ParadeDB](https://www.paradedb.com/) versions `0.11.x - 0.15.1`. Refer to the table below for compatability:\n\n| ParadeDB version    | Paradex version |\n|---------------------|-----------------|\n| `0.11.0` - `0.14.1` | `0.3.3`         |\n| `0.15.x`            | `0.4.x`         |","ref":"readme.html"},{"type":"extras","title":"Installation - Paradex","doc":"Add `:paradex` to your list of dependencies in `mix.exs`:\n\n<!-- BEGIN: VERSION -->\n```elixir\ndef deps do\n  [\n    {:paradex, \"~> 0.4.0\"}\n  ]\nend\n```\n<!-- END: VERSION -->\n\nDocumentation is available on [HexDocs](https://hexdocs.pm/paradex/readme.html) and may also be generated with [ExDoc](https://github.com/elixir-lang/ex_doc).","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Paradex","doc":"You may install ParadeDB via [Docker](https://docs.paradedb.com/documentation/getting-started/install), or by [loading the extensions](https://docs.paradedb.com/deploy/self-hosted/extensions) into an existing Postgres database.\n\nCreate `lib/postgrex_types.ex` with the contents below. You may omit `Pgvector.extensions()` if you aren't working with vectors:\n\n```elixir\nPostgrex.Types.define(\n  ParadexApp.PostgrexTypes,\n  Pgvector.extensions() ++ Paradex.extensions() ++ Ecto.Adapters.Postgres.extensions(),\n  []\n)\n```\n\nAdd the following to `config/config.exs`:\n```elixir\nconfig :my_app, MyApp.Repo, types: MyApp.PostgrexTypes\n```\n\n\nCreate your [Ecto schema](https://github.com/Moosieus/paradex/blob/main/test/support/paradex_app/call.ex) and a [search index](https://docs.paradedb.com/documentation/indexing/create_index) in your [migrations](https://github.com/Moosieus/paradex/blob/main/priv/repo/migrations/20241013014316_setup.exs).\n\nOnce complete, you're ready to run search queries:\n\n```elixir\nimport Ecto.Query\nimport Paradex\n\nalias MyApp.Call\nalias MyApp.Repo\n\nfrom(\n  c in Call,\n  where: c.transcript ~> \"bus\"\n)\n|> Repo.all()\n```\n\nMore examples are available in the [API docs](https://hexdocs.pm/paradex/Paradex.html).","ref":"readme.html#usage"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.4.0 (2025-02-06) - Changelog","doc":"* ParadeDB `0.15.0` removes `paradedb.fuzzy_phrase` in favor of the new `paradedb.match`. Subsequently `fuzzy_phrase/6` has been removed from Paradex and replaced with `match/6`.\n* `match/6` currently does not support the custom tokenizer option via the `tokenizer` parameter. Consequently the query will always be tokenized the same way as the field was at index time.\n* A version compatability table has been added to `README.md`.","ref":"changelog.html#v0-4-0-2025-02-06"},{"type":"extras","title":"v0.3.3 (2024-01-14) - Changelog","doc":"* There are no code changes in this release. `README.md` has been updated to include compatibility with ParadeDB `0.14.x`.","ref":"changelog.html#v0-3-3-2024-01-14"},{"type":"extras","title":"v0.3.2 (2024-11-22) - Changelog","doc":"* `::fieldname` casts have been updated to `::paradedb.fieldname`. This change is backwards compatible to `0.11.0`.\n* Test/example migrations have been updated to demo Paradex `0.13.0`'s new index creation syntax.\n* Be mindful that upgrading to ParadeDB `0.13.0` will require you to revise your existing migrations.","ref":"changelog.html#v0-3-2-2024-11-22"},{"type":"extras","title":"v0.3.1 (2024-11-10) - Changelog","doc":"* There are no code changes in this release. `README.md` has been updated to include compatibility with ParadeDB `0.12.x`.\n* Included `CHANGELOG.md` and fixed macro groupings in hexdocs.","ref":"changelog.html#v0-3-1-2024-11-10"},{"type":"extras","title":"v0.3.0 (2024-11-05) - Changelog","doc":"* Added `Paradex.extensions/0` which presently consists of `[ Paradex.FieldName ]`.\n  * This allows Postgrex to parameterize field names in ParadeDB query objects, solving issue [#4](https://github.com/Moosieus/paradex/issues/4).\n* Updated docs to include instructions for the above.\n\n*If you've configured everything correctly and are receiving an error that `fieldname` doesn't exist, try updating ParadeDB.*","ref":"changelog.html#v0-3-0-2024-11-05"},{"type":"extras","title":"v0.2.0 (2024-10-27) - Changelog","doc":"* Added `lenient` and `conjunction_mode` options to `parse` (non-breaking).\n* Added `lenient` option to `parse_with_field` as the 2nd argument, making `conjunction_mode` the 3rd (minor breaking change).","ref":"changelog.html#v0-2-0-2024-10-27"},{"type":"extras","title":"v0.1.0 (2024-10-19) - Changelog","doc":"Initial Release.","ref":"changelog.html#v0-1-0-2024-10-19"},{"type":"extras","title":"Hybrid Search Example","doc":"# Hybrid Search Example\n\n```elixir\nMix.install(\n  [\n    # the ecto we know and love\n    {:postgrex, \">= 0.0.0\"},\n    {:pgvector, \"~> 0.3.0\"},\n    {:ecto, \"~> 3.0\"},\n    {:ecto_sql, \"~> 3.0\"},\n    # Nx stuff\n    {:bumblebee, \"~> 0.6.0\"},\n    {:nx, \"~> 0.9.0\"},\n    {:exla, \"~> 0.9.0\"},\n    {:axon, \"~> 0.7.0\"},\n    {:kino, \"~> 0.14.0\"},\n    # paradex\n    {:paradex, path: Path.join(__DIR__, \"../\"), env: :test}\n  ],\n  # I've configured this for my rig, yours will likely differ.\n  config: [\n    paradex: [\n      {:ecto_repos, [ParadexApp.Repo]},\n      {ParadexApp.Repo, [\n        pool: Ecto.Adapters.SQL.Sandbox,\n        database: \"paradex_test\",\n        username: \"postgres\",\n        password: \"postgres\",\n        hostname: \"localhost\",\n        timeout: 600_000,\n        ownership_timeout: 600_000,\n        pool_timeout: 600_000,\n        port: 5433,\n        types: ParadexApp.PostgrexTypes\n      ]}\n    ],\n    exla: [\n      clients: [\n        cuda: [\n          platform: :cuda,\n          memory_fraction: 0.85,\n          device_id: 0\n        ]\n      ],\n      client: :cuda\n    ],\n    nx: [\n      default_backend: {EXLA.Backend, client: :cuda, device_id: 0}\n    ]\n  ],\n  config_path: :paradex,\n  lockfile: :paradex\n)\n```","ref":"hybrid_search.html"},{"type":"extras","title":"Summary - Hybrid Search Example","doc":"**Full disclaimer:** *This ain't no peer reviewed study, and I'm using lots of big words here that I don't ~~quite~~ understand. If I got something wrong here, please call me out.*\n\n<!-- livebook:{\"break_markdown\":true} -->\n\nThis livebook demonstrates a means to perform hybrid search using ParadeDB and Ecto. We'll use Paradex's sample dataset, which is mostly radio chatter between public bus drivers. The text embeddings will be generated with Nx. This example's mostly cribbed from [ParadeDB's tutorial](https://docs.paradedb.com/documentation/guides/hybrid).\n\nWe'll start with our top-level imports:\n\n```elixir\nimport Ecto.Query\nimport Paradex\nimport Pgvector.Ecto.Query\n\nalias ParadexApp.Repo\nalias ParadexApp.Call\n\nRepo.start_link()\n```\n\nNext we'll load a transformer for generating text embeddings. I've gone with `sentence-transformers/all-MiniLM-L6-v2`, as I quite frankly don't know any better.\n\n```elixir\n{:ok, model_info} = Bumblebee.load_model({:hf, \"sentence-transformers/all-MiniLM-L6-v2\"})\n{:ok, tokenizer} = Bumblebee.load_tokenizer({:hf, \"sentence-transformers/all-MiniLM-L6-v2\"})\nserving = Bumblebee.Text.TextEmbedding.text_embedding(model_info, tokenizer)\n```\n\nNext up, there parameters for our hybrid search. I'm using a simple Tantivy query on the text search side for demo sake. You could elect to use a more advanced query, though.\n\n```elixir\n%{embedding: embedding} = Nx.Serving.run(serving, \"bus late behind schedule\")\nsearch = \"bus late behind schedule\"\nvector = Pgvector.new(embedding)\ntop_n = 25\n```\n\nWe'll run our two searches and rank the `top_n` results. I'm using L2 distanceas I quite frankly don't know any better.\n\n```elixir\nsemantic_search =\n  from(\n    c in Call,\n    select: %{\n      id: c.id,\n      rank: fragment(\"RANK() OVER (ORDER BY ?)\", l2_distance(c.embedding, ^vector))\n    },\n    order_by: [asc: l2_distance(c.embedding, ^vector)],\n    limit: ^top_n\n  )\n\nbm25_search =\n  from(\n    c in Call,\n    select: %{\n      id: c.id,\n      rank: fragment(\"RANK() OVER (ORDER BY paradedb.score(?) DESC)\", c.id)\n    },\n    where: c.transcript ~> ^search,\n    limit: ^top_n\n  )\n\n```\n\nWe can tie them together with reciprocal rank fusion like so:\n\n```elixir\nhybrid_search =\n  from(\n    sem in subquery(semantic_search),\n    full_join: bm25 in subquery(bm25_search), on: sem.id == bm25.id,\n    order_by: [desc: fragment(\"score\"), asc: sem.id],\n    select: %{\n      id: coalesce(sem.id, bm25.id),\n      score: fragment(\"COALESCE(1.0 / (60 + ?), 0.0) + COALESCE(1.0 / (60 + ?), 0.0)\", sem.rank, bm25.rank)\n    },\n    limit: ^top_n\n  )\n```\n\nWe can either `join/5` our schema in the query above, or use it as a subquery for a bit more flexibility, say for preloading:\n\n```elixir\nfrom(\n  c in Call,\n  join: r in subquery(hybrid_search), on: c.id == r.id,\n  preload: [:talk_group],\n  select: %{score: r.score, call: c}\n)\n\n:ok\n```\n\nThat'll print a bit much for demonstration sake, so I'll abridge the select query here:\n\n```elixir\nfrom(\n  c in Call,\n  join: r in subquery(hybrid_search), on: c.id == r.id,\n  select: %{score: r.score, id: c.id, transcript: c.transcript},\n  limit: 7\n)\n|> Repo.all()\n```","ref":"hybrid_search.html#summary"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}